from bottle import route, run, template, TEMPLATE_PATH,request, static_file
import os 
import time
import re

def static_path():
    abs_app_dir_path = os.path.dirname(os.path.realpath(__file__)) + os.path.sep+ "..";
    abs_views_path = os.path.join(abs_app_dir_path, 'static');
    return abs_views_path;

def exec(cmd):
    with os.popen(cmd, "r") as f:
        return f.read()

def search_str(pattern, data):
    return re.search( pattern, data, re.M|re.I)

def load_info():
    t_deb_str = exec("dpkg -l | grep ed- | awk '{print $2}'");
    t_debs = t_deb_str.splitlines();
    t_info = {}
    for t_deb in t_debs:
        if t_deb == "ed-codesys-pem":
            continue
        elif t_deb.startswith("ed-codesys-"):
            t_power = t_deb[11:]
            t_info["power"] = t_power.strip()
        else:
            b_firmware = search_str(r'^ed-(.*)-firmware$', t_deb)
            if b_firmware:
                t_info["firmware"] = b_firmware.group(1).strip()
                t_info["firmware"] = t_info["firmware"] + "(" + exec("dpkg -l | grep ed-"+t_info["firmware"]+"-firmware | awk '{print $3}'").strip() +")"
            else:
                b_bsp = search_str(r'^ed-(.*)-bsp$', t_deb)
                if b_bsp:
                    t_info["firmware"] = b_bsp.group(1).strip()
                    t_info["firmware"] = t_info["firmware"] + "(" + exec("dpkg -l | grep ed-"+t_info["firmware"]+"-bsp | awk '{print $3}'").strip() +")"
    return t_info
        

@route('/static/<filename:path>')
def static(filename):
    return static_file(filename, root=static_path());

@route('/backup', method='POST')
def do_backup():
    t_time = time.strftime("%Y%m%d", time.localtime());
    t_static = static_path();
    t_output = "{}/downloads/EDA_pem_backup_{}.zip".format(t_static, t_time);
    os.system("rm -f {}".format(t_output));
    if os.system("zip {} /etc/eda/* -x '/etc/eda/3S.dat'".format(t_output)) == 0 :
        return "/static/downloads/EDA_pem_backup_{}.zip".format(t_time);
    return str("-1");

@route('/create', method='POST')
def do_backup():
    t_static = static_path();
    if os.system("mkdir -p /etc/eda && cd /etc/eda/ && eda-codesys") == 0:
        os.system("cp /etc/eda/eda-rsa.pub {}/downloads/eda-rsa-v2.pub".format(t_static));
        return "/static/downloads/eda-rsa-v2.pub";
    return str("-2");

@route('/device/file', method='POST')
def do_device_file():
    t_static = static_path();
    t_file = None
    if os.path.exists("/etc/eda"):
        for f in os.listdir("/etc/eda"):
            if f.endswith(".xml"):
                t_file = f;
                break
    if t_file is not None:
        os.system(f"cp /etc/eda/{t_file} {t_static}/downloads/{t_file}")
        return f"/static/downloads/{t_file}"
    return str("device_file_err1");

@route('/close', method='POST')
def do_close():
    os.system("systemctl disable eda-pem-manager.service")
    os.system("systemctl stop eda-pem-manager.service")
    return str("-2");

@route('/license', method='POST')
def do_license():
    # name = request.forms.name
    data = request.files.data
    if data and data.file:
        # raw = data.file.read() # This is dangerous for big files
        filename = data.filename
        # filepath = os.path.join("/etc/eda/", filename);
        filepath = "/etc/eda/eda-v1.dat"
        data.save(filepath, overwrite=True);
        # os.remove(filepath);
        os.system("systemctl restart codesyscontrol.service");
        return "You uploaded %s." % (filename)
    return "You missed a field."

@route('/upload', method='POST')
def do_upload():
    # name = request.forms.name
    data = request.files.data
    if data and data.file:
        # raw = data.file.read() # This is dangerous for big files
        filename = data.filename
        filepath = os.path.join(static_path(), filename);
        data.save(filepath, overwrite=True);
        os.system("mkdir -p /etc/eda && unzip -o {} -d /".format(filepath));
        os.remove(filepath);
        os.system("systemctl restart codesyscontrol.service");
        return "You uploaded %s." % (filename)
    return "You missed a field."

@route('/admin')
def index():
    return template('index', name="admin", info=load_info());

@route('/')
def index():
    return template('index', name="user", info=load_info());

if __name__ == '__main__':
    abs_app_dir_path = os.path.dirname(os.path.realpath(__file__)) + os.path.sep+ "..";
    abs_views_path = os.path.join(abs_app_dir_path, 'views');
    abs_pems_path = os.path.join(abs_app_dir_path, 'pems');
    TEMPLATE_PATH.insert(0,abs_views_path);
    os.system("mkdir -p {}/downloads".format(static_path()))
    run(host='0.0.0.0', port=8100, debug=False);
    # run(host='0.0.0.0', port=8080, debug=False,server='gunicorn',reloader=1,keyfile='{}/key.pem'.format(abs_pems_path),certfile='{}/cert.pem'.format(abs_pems_path));